import java.net.*;
import java.io.*;
import java.applet.*;

public class gsm_decoder implements Runnable {
  static globals globs; 
  static int index = 0;
 // indicates which of the two buffers is being decoded into currently.
  static int tim;
  static short exp, mant;
  static short LARp[] = new short[8];
  static short LARpp_j[] = new short[8];
  static short LARpp_j_1[] = new short[8];
  static short LARc[] = new short[8];  /* log area ratios */
  static short Nc[] = new short[4];
  static short Mc[] = new short[4];
  static short bc[] = new short[4];
  static short xmaxc[] = new short[4];
  static short xmc[] = new short[13*4];
  static short erp[] = new short[40];
  static short wt[] = new short[160];
  static short xMp[] = new short[13];

  public int read_frame() {
    int i;
	int readval;
	int times;


    for(i=0; i<33; i++) {
      try {
		readval = globs.source.dp.readUnsignedByte();
		globs.gsmdec.gsm_frame[i] =	readval;
      }
      catch(Exception e) {
		System.out.println(e);
        System.out.println("Error reading unsigned byte from source frame.");
        return (-1);
      }
    }
    return 0;
  }

  public static void APCM_quantization_xmaxc_to_exp_mant(short xmaxc) {
    short exp_tmp, mant_tmp;

    /* Compute exponent and mantissa of the decoded version of xmaxc */

    exp_tmp = 0;
    if(xmaxc > 15)
      exp_tmp = (short)((xmaxc >> 3) - 1);
    mant_tmp = (short)(xmaxc - (exp_tmp << 3));

    if(mant_tmp == 0) {
      exp_tmp = -4;
      mant_tmp = 7;
    }
    else {
      while(mant_tmp <= 7) {
        mant_tmp = (short)(mant_tmp << 1 | 1);
        exp_tmp--;
      }
      mant_tmp -= 8;
    }

    if(!( exp_tmp >= -4 && exp_tmp <= 6)) {
      System.out.println("Assert failed.");
      System.exit(-1);
    }
    if(!(mant_tmp >= 0 && mant_tmp <= 7)) {
      System.out.println("Assert failed.");
      System.exit(-1);
    }

    exp = exp_tmp;
    mant = mant_tmp;
  }

/* This part is for decoding the RPE sequence of coded xMc[0..12]
*  samples to obtain the xMp[0..12] array. Table 4.6 is used to get 
*  the mantissa of xmaxc (FAC[0..7]).
*/
  public void APCM_inverse_quantization(int j) {
    int i, k=0;
    short temp, temp1, temp2, temp3;
    int ltmp;    
  
    if(!(mant >=0 && mant <=7)) {
      System.out.println("Assert failed.");
      System.exit(-1);
    }
  
	
    temp1 = table.gsm_FAC[mant];
    temp2 = add.gsm_sub((short)6, exp);
    temp3 = add.gsm_asl((short)1, add.gsm_sub(temp2, (short)1));
	
    for(i=13; ;i--) {
	  if(i<=0) break;
      if(!(xmc[j] <= 7 && xmc[j] >= 0)) {
        System.out.println("Assert failed.");
        System.exit(-1);
      }
      
      temp = (short)((xmc[j++] << 1) - 7);
	  
      
      if(!(temp<=7 && temp>=-7)) {
        System.out.println("Assert failed.");
        System.exit(-1);
      }

	  temp <<= 12;
	 
      
	  temp = add.gsm_mult_r(temp1, temp);
	  
      
	  temp = add.gsm_add(temp, temp3);
	       
	 	  
      xMp[k++] = (short)add.gsm_asr(temp, temp2);
	  	  
    }
	
  }

/*
 *  This procedure computes the reconstructed long term residual signal
 *  ep[0..39] for the LTP analysis filter.  The inputs are the Mc
 *  which is the grid position selection and the xMp[0..12] decoded
 *  RPE samples which are upsampled by a factor of 3 by inserting zero
 *  values.
 */
  public static void RPE_grid_positioning(short Mc) {
    int i = 13, j=0, k=0;

    if(!(Mc >= 0  && Mc <= 3)) {
      System.out.println("Assert failed.");
      System.exit(-1);
    }
  //	System.out.println("\r\nMc enters as "+Mc+"\r\n");
//	System.out.println("ep is:\r\n");
    switch(Mc) {
      case 3 : erp[j++] = 0;
			  // System.out.println(erp[j-1]);
               do {
                 erp[j++] = 0;
				// System.out.println(erp[j-1]);
      			 erp[j++] = 0;
			//	 System.out.println(erp[j-1]);
      			 erp[j++] = xMp[k++];
			//	 System.out.println(erp[j-1]);
                 i--;
               } while(i > 0);
			   break;
      case 2 : do {
                 erp[j++] = 0;
			//	 System.out.println(erp[j-1]);
      			 erp[j++] = 0;
			//	 System.out.println(erp[j-1]);
      			 erp[j++] = xMp[k++];
			//	 System.out.println(erp[j-1]);
                 i--;
               } while(i > 0);
			   break;
      case 1 : erp[j++] = 0;
	//	  System.out.println(erp[j-1]);
               erp[j++] = xMp[k++]; 
	//		   System.out.println(erp[j-1]);
               i--;
		       while(i > 0) {
                 erp[j++] = 0;
	//			 System.out.println(erp[j-1]);
      			 erp[j++] = 0;
	//			 System.out.println(erp[j-1]);
      			 erp[j++] = xMp[k++];
	//			 System.out.println(erp[j-1]);
                 i--;
               } 
			   break;
      case 0 : erp[j++] = xMp[k++]; 
	//	  System.out.println(erp[j-1]);
               i--;
		       while(i > 0) {
                 erp[j++] = 0;
	//			 System.out.println(erp[j-1]);
      			 erp[j++] = 0;
	//			 System.out.println(erp[j-1]);
      			 erp[j++] = xMp[k++];
	//			 System.out.println(erp[j-1]);
                 i--;
               } 
			   break;
    }
    
//	System.out.println("count is "+j+"\r\n");
    while(++Mc < 4) {
	  //System.out.println("Mc is "+Mc+"\r\n");
	  erp[j++] = 0;
	}
//	System.out.println("erp is :\r\n");
//	for(i=0;i<40;i++)
//	  System.out.println(erp[i]);
//	System.out.println("\r\n");
  }


  public void Gsm_RPE_Decoding(int ind1, int ind2, int j) {
    short xmaxcr = xmaxc[ind1];
    short Mcr = Mc[ind2];
    APCM_quantization_xmaxc_to_exp_mant(xmaxcr); 
    APCM_inverse_quantization(j);
    RPE_grid_positioning(Mcr);
  }

  public void Gsm_Long_Term_Synthesis_Filtering(int ind1, int ind2) {
    int ltmp;
    short k;
    short brp, drpp, Nr;
    short Ncr = Nc[ind1];
    short bcr = bc[ind2];

    /* Check the limits of Nr */
    Nr = Ncr < 40 || Ncr > 120 ? globs.gsmdec.gsm.nrp : Ncr;
    globs.gsmdec.gsm.nrp = Nr;

    if(!(Nr >= 40 && Nr <= 120)) {
      System.out.println("Assert failed.");
      System.exit(-1);
    }

    /* Decoding of the LTP gain bcr */
    brp = table.gsm_QLB[bcr];

    /* Computation of the reconstructed short term residual
       signal drp[0..39] */
    if(!(brp != globs.MIN_WORD)) { 
      System.out.println("Assert failed.");
      System.exit(-1);
    }
    
    for(k=0; k<=39; k++) {
      drpp = add.gsm_mult_r(brp,globs.gsmdec.gsm.dp0[120+k-Nr]);
      globs.gsmdec.gsm.dp0[120+k] = add.gsm_add(erp[k], drpp);
    }

    /* Update of the reconstructed short term residual signal
       dp0[-1..-120] */
  
    for(k=0; k<=119; k++)
      globs.gsmdec.gsm.dp0[k] = globs.gsmdec.gsm.dp0[40+k]; 
  }
    
  public static void Decoding_of_the_coded_Log_Area_Ratios() {
    short temp1;
    int j=0, k=0;
    /*  This procedure requires for efficient implementation
     *  two tables.
     *
     *  INVA[1..8] = integer( (32768 * 8) / real_A[1..8])
     *  MIC[1..8]  = minimum value of the LARc[1..8]
     */
    temp1 = (short)(add.gsm_add(LARc[j++], (short)(-32)) << 10);   // STEP
    temp1 = add.gsm_sub( temp1, (short)(0 << 1));        
    temp1 = add.gsm_mult_r( (short)13107, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);

    temp1 = (short)(add.gsm_add(LARc[j++],(short)(-32)) << 10);
    temp1 = (short)(add.gsm_sub( temp1,(short)(0 << 1)));        
    temp1 = add.gsm_mult_r( (short)13107, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++], (short)(-16)) << 10);
    temp1 = add.gsm_sub( temp1, (short)(2048 << 1));        
    temp1 = add.gsm_mult_r((short) 13107, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++], (short)(-16)) << 10);
    temp1 = add.gsm_sub( temp1, (short)(-2560 << 1));        
    temp1 = add.gsm_mult_r((short) 13107, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
					add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++], (short)(-8)) << 10);
    temp1 = add.gsm_sub( temp1,(short)(94 << 1));        
    temp1 = add.gsm_mult_r((short) 19223, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++],(short)(-8)) << 10);
    temp1 = add.gsm_sub( temp1,(short)(-1792 << 1));        
    temp1 = add.gsm_mult_r((short) 17476, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++],(short)(-4)) << 10);
    temp1 = add.gsm_sub( temp1,(short)(-341 << 1));        
    temp1 = add.gsm_mult_r((short) 31454, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
    temp1 = (short)(add.gsm_add(LARc[j++],(short)(-4)) << 10);
    temp1 = add.gsm_sub( temp1,(short)(-1144 << 1));        
    temp1 = add.gsm_mult_r((short) 29708, temp1 );      
    globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k++] = 
						add.gsm_add( temp1, temp1 );
	//System.out.println(globs.gsmdec.gsm.LARpp[globs.gsmdec.gsm.j][k-1]);
  }

  public static void Coefficients_0_12() {
    int i, j=0;
 //   System.out.println("\r\nLARp in 0-12 is\r\n");
	for(i=1; i<=8; i++) {
      LARp[j] = (short)add.gsm_add(
             (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j] >> 2),
             (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j][j] >> 2));
//	  System.out.println(" LARpp_j :"+globs.gsmdec.gsm.LARpp[globs.gsm_j][j]);
//      System.out.println(" LARpp_j_1 :"+globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j]);
	  


//	  System.out.println(" first "+LARp[j]);

      LARp[j] = (short)add.gsm_add(
                LARp[j],
             (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j] >> 1));
//	  System.out.println(LARp[j]);
      j++;
    }

  }
                             
  public static void Coefficients_13_26() {
    int i, j=0;

    for(i=1; i<=8; i++) {
      LARp[j] = add.gsm_add(
          (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j] >> 1),
          (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j][j] >> 1));
      j++;
    }
  }

  public static void Coefficients_27_39() {
    int i, j=0;

	//System.out.println("\r\nLARp in 27-39 is \r\n");
    for(i=1; i<=8; i++) {
      LARp[j] = (short)add.gsm_add(
          (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j] >> 2),
          (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j][j] >> 2));
	  //System.out.println(" LARpp_j :"+ globs.gsmdec.gsm.LARpp[globs.gsm_j][j]);
	  //System.out.println(" LARpp_j_1 >> 1 :"+ (globs.gsmdec.gsm.LARpp[globs.gsm_j_1][j] >>1));
	  //System.out.println(" first "+LARp[j]);
      LARp[j] = (short)add.gsm_add(
		     LARp[j],
             (short)(globs.gsmdec.gsm.LARpp[globs.gsm_j][j] >> 1));
	  //System.out.println(LARp[j]);
      j++;
    }
  }

  public static void Coefficients_40_159() {
    int i, j=0;

    for(i=1; i<=8; i++) {
      LARp[j] = globs.gsmdec.gsm.LARpp[globs.gsm_j][j];
      j++;
    }
  }

  public static void LARp_to_rp() {
/*
 *  The input of this procedure is the interpolated LARp[0..7] array.
 *  The reflection coefficients, rp[i], are used in the analysis
 *  filter and in the synthesis filter.
 */
    int i, j=0;
    short temp;
   
    for(i=1; i<=8; i++, j++) {
      if(LARp[j] < 0) {
        temp =(short)(LARp[j] == globs.MIN_WORD ? globs.MAX_WORD : -(LARp[j]));
        LARp[j] = (short)(- ((temp < 11059) ? temp <<1
                  : (( temp < 20070) ? temp + 11059
                  :  add.gsm_add( (short)(temp >>> 2), (short)26112 ))));
      } 
      else {
        temp  = LARp[j];
        LARp[j] = (short)((temp < 11059) ? temp << 1
                : ((temp < 20070) ? temp + 11059
                :  add.gsm_add( (short)(temp >>> 2), (short)26112 )));
      }
    }	 
  }

  public static void Short_term_synthesis_filtering(int k, int ind) {
    int i, p=0;
    short sri, tmp1, tmp2;
    int ltmp; 
	//System.out.println("k is "+k+"\r\n");
    while(k > 0) {
      k--;
      sri = wt[ind];
	  for(i=8;i > 0;) {
        i--;
        tmp1 = LARp[i];
		//System.out.println("tmp1 is "+tmp1);
        tmp2 = globs.gsmdec.gsm.v[i];
		//System.out.println(" tmp2 is "+tmp2+"\r\n");
        tmp2 = (short)( tmp1 == globs.MIN_WORD && tmp2 == globs.MIN_WORD
                ? globs.MAX_WORD
                : 0x0FFFF & (( (int)tmp1 * (int)tmp2
                         + 16384) >>> 15)) ;

        sri  = add.gsm_sub( sri, tmp2 );
		//System.out.println(sri+" ");
        tmp1  = (short)( tmp1 == globs.MIN_WORD && sri == globs.MIN_WORD
                ? globs.MAX_WORD
                : 0x0FFFF & (( (int)tmp1 * (int)sri
                         + 16384) >>> 15)) ;

        globs.gsmdec.gsm.v[i+1] = 
                     add.gsm_add( globs.gsmdec.gsm.v[i], tmp1);
      }
      globs.gsmdec.gsm_signal[160*globs.N*index + 160*tim + ind] = globs.gsmdec.gsm.v[0] = sri;
	  ind++;
      //System.out.println("globs.gsmdec.gsm_signal["+(p-1)+"] = "+globs.gsmdec.gsm_signal[p-1]);	  
    }
	//System.out.println("\r\nsig[0] is "+ globs.gsmdec.gsm_signal[0]+"\r\n");
	
  }

  public void Gsm_Short_Term_Synthesis_Filter() {
	  int pp;
	  globs.gsm_j_1 = globs.gsmdec.gsm.j;
//	  System.out.println("j is "+ globs.gsm_j);
	  globs.gsm_j = (globs.gsmdec.gsm.j ^= 1);
//	  System.out.println("j1 is "+globs.gsm_j_1+"\r\n");
	  
/* short LARc, wt */
    Decoding_of_the_coded_Log_Area_Ratios();
	
    Coefficients_0_12();
/*	System.out.println("\r\n0-12\r\n");
	for(pp=0;pp<8;pp++)
	System.out.println(LARp[pp]);*/

    LARp_to_rp();
//	System.out.println("globs.1 = "+globs.gsmdec.gsm_signal[0]+" ");
    Short_term_synthesis_filtering(13, 0);
	/*
	System.out.println("k=13 s= \r\n");
	for(pp=0;pp<13;pp++)
	  System.out.println(globs.gsmdec.gsm_signal[pp]+" ");
	System.out.println("\r\n");*/

//	System.out.println("globs.1 = "+globs.gsmdec.gsm_signal[0]+" ");
    Coefficients_13_26();
	/* System.out.println("\r\n13-26\r\n");
	for(pp=0;pp<8;pp++)
	System.out.println(LARp[pp]);*/

    LARp_to_rp();
    Short_term_synthesis_filtering(14, 13);
//	System.out.println("globs.1 = "+globs.gsmdec.gsm_signal[0]+" ");
	/*
	System.out.println("k=14 s= \r\n");
	for(pp=0;pp<13;pp++)
	  System.out.println(globs.gsmdec.gsm_signal[pp]+" ");
	System.out.println("\r\n");*/

    Coefficients_27_39();
	/* System.out.println("\r\n27-39\r\n");
	for(pp=0;pp<8;pp++)
	System.out.println(LARp[pp]);*/

    LARp_to_rp();
    Short_term_synthesis_filtering(13, 27);
//	System.out.println("globs.1 = "+globs.gsmdec.gsm_signal[0]+" ");
	/* System.out.println("k=13 s= \r\n");
	for(pp=0;pp<13;pp++)
	  System.out.println(globs.gsmdec.gsm_signal[pp]+" ");
	System.out.println("\r\n");*/

    Coefficients_40_159();
/*	System.out.println("\r\n40-159\r\n");
	for(pp=0;pp<8;pp++)
	System.out.println(LARp[pp]);*/

    LARp_to_rp();
    Short_term_synthesis_filtering(120, 40);   
	
  	/* System.out.println("k=120 s= \r\n");		 
	for(pp=0;pp<120;pp++)
	  System.out.println(globs.gsmdec.gsm_signal[pp]+" ");
	System.out.println("\r\n");*/
  }

    
  public static void Postprocessing() {
    int k, p=0;
	int pointer;
    short tmp;
    short msr = globs.gsmdec.gsm.msr;
	//System.out.println("Sigs are ");
    for(k=160;k > 0;) {
      k--;
      tmp = add.gsm_mult_r( msr, (short)28180 );
	  pointer = 160*globs.N*index + 160*tim +p;
      msr = add.gsm_add(globs.gsmdec.gsm_signal[pointer], tmp); 	// Deemphasis
      globs.gsmdec.gsm_signal[pointer]  = 
         (short)(add.gsm_add(msr, msr) & 0xFFF8);	// Truncation & Upscaling 
	  //System.out.println("d: "+index+" "+tim +" "+p+" "+ globs.gsmdec.gsm_signal[pointer]);
	  p++;
    }
    globs.gsmdec.gsm.msr = msr;
  }

  public void Gsm_Decoder() {
/* short LARc, Nc, bc, Mc, xmaxc, xmc */
    int j, k;

    for(j=0; j<=3; j++) {
      Gsm_RPE_Decoding(j, j, j*13);
      Gsm_Long_Term_Synthesis_Filtering(j, j);

      for(k=0; k<=39; k++)
        wt[j*40 + k] = globs.gsmdec.gsm.dp0[k + 120];
//	  System.out.println("drp is");
//	  for(k=0;k<40;k++)
//		System.out.println(globs.gsmdec.gsm.dp0[k + 120]);
//	  	System.out.println("\r\n");
    }
	//System.out.println("S--j " +globs.gsmdec.gsm.j);

    Gsm_Short_Term_Synthesis_Filter();
	
	Postprocessing();
/*	System.out.println("These are the signals... is\r\n");
	
	for(k=0;k<160;k++)
	  System.out.println(globs.gsmdec.gsm_signal[k]);
	System.out.println("\r\n");*/

  }

  public int gsm_decode() {
    int i = 0;
    if (((globs.gsmdec.gsm_frame[0] >>> 4) & 0x0F) 
				!= globs.GSM_MAGIC) return (-1);

    LARc[0] = (short)((globs.gsmdec.gsm_frame[i++] & 0xF) << 2); 	/* 1 */
    LARc[0] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    LARc[1]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x3F);
    LARc[2]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x1F);
    LARc[3]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x7) << 2);
    LARc[3] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    LARc[4]  = (short)((globs.gsmdec.gsm_frame[i] >>> 2) & 0xF);
    LARc[5]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x3) << 2);
    LARc[5] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    LARc[6]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    LARc[7]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    Nc[0]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7F);
    bc[0]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 1);
    bc[0] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    Mc[0]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x3);
    xmaxc[0]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1F) << 1);
    xmaxc[0] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[0]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[1]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[2]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[2] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[3]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[4]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    xmc[5]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x7);
    xmc[6]  = (short)((globs.gsmdec.gsm_frame[i] >>> 2) & 0x7);
    xmc[7]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x3) << 1);        /* 10 */
    xmc[7] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[8]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[9]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[10]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[10] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[11]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[12]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    Nc[1]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7F);
    bc[1]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 1);
    bc[1] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    Mc[1]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x3);
    xmaxc[1]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1F) << 1);
    xmaxc[1] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[13]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[14]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[15]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[15] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[16]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[17]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    xmc[18]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x7);
    xmc[19]  = (short)((globs.gsmdec.gsm_frame[i] >>> 2) & 0x7);
    xmc[20]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x3) << 1);
    xmc[20] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[21]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[22]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[23]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[23] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[24]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[25]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    Nc[2]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7F);
    bc[2]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 1);     /* 20 */
    bc[2] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    Mc[2]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x3);
    xmaxc[2]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1F) << 1);
    xmaxc[2] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[26]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[27]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[28]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[28] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[29]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[30]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    xmc[31]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x7);
    xmc[32]  = (short)((globs.gsmdec.gsm_frame[i] >>> 2) & 0x7);
    xmc[33]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x3) << 1);
    xmc[33] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[34]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[35]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[36]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[36] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[37]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[38]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);
    Nc[3]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7F);
    bc[3]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 1);
    bc[3] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    Mc[3]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x3);
    xmaxc[3]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1F) << 1);
    xmaxc[3] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[39]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[40]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[41]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[41] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[42]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[43]  = (short)(globs.gsmdec.gsm_frame[i++] & 0x7);          /* 30  */
    xmc[44]  = (short)((globs.gsmdec.gsm_frame[i] >>> 5) & 0x7);
    xmc[45]  = (short)((globs.gsmdec.gsm_frame[i] >>> 2) & 0x7);
    xmc[46]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x3) << 1);
    xmc[46] |= (short)((globs.gsmdec.gsm_frame[i] >>> 7) & 0x1);
    xmc[47]  = (short)((globs.gsmdec.gsm_frame[i] >>> 4) & 0x7);
    xmc[48]  = (short)((globs.gsmdec.gsm_frame[i] >>> 1) & 0x7);
    xmc[49]  = (short)((globs.gsmdec.gsm_frame[i++] & 0x1) << 2);
    xmc[49] |= (short)((globs.gsmdec.gsm_frame[i] >>> 6) & 0x3);
    xmc[50]  = (short)((globs.gsmdec.gsm_frame[i] >>> 3) & 0x7);
    xmc[51]  = (short)(globs.gsmdec.gsm_frame[i] & 0x7);            /* 33 */
	
    Gsm_Decoder();

    return 0;
}


 
  public void run() {
	    
    	boolean first = true;
	    while(globs.grabframe != null && globs.player != null) {
	 // System.out.println("In grabber");
      
      try {
        while(globs.source.dp.available() != 0) {
		 // System.out.println("Is available for reading.");
		  if(globs.flag[index] == 1) {
	// suspend if buffer not played as yet.
            globs.awake[0] = false;
            try {
		      globs.grabframe.suspend();
            }
            catch(Exception e) {
              System.out.println("Suspend error");
              System.exit(-1);
            }
          }
    

		  System.out.println("Decoder started on buffer "+index+"\r\n ");
		  for(tim=0;tim<globs.N;tim++) {
		
			if(read_frame() == 0) {
		    //  System.out.println("Read a frame.");
              if(gsm_decode() != 0) {
                System.out.println("Bad frame in "+globs.source.url); 
                System.exit(-1);
              }
		    }
		    else {
              System.out.println("grabber exiting.");
              System.exit(-1);
            }

		 }
		 globs.flag[index] = 1;
		 System.out.println("Decoder done with buffer "+index+"\r\n ");
         index ^= 1;
 // switch buffers and wake up player if it was suspended.
		 if(!first) {
         if(!globs.awake[1]){
           globs.awake[1] = true;
         try {
           globs.player.resume();
         }
         catch(Exception e){
           System.out.println("Resume error");
         }
         }
		 }
		 if(first) first = false;
         
      }
		System.out.println("No more data.");
		try {
		  
		  globs.grabframe.suspend();
		}
		catch(Exception e) {}
		
      }
      catch(IOException e) {
        System.out.println("Availability error.");
        System.exit(-1);
      }
    }
  }
}
