import java.net.*;
import java.io.*;
import java.applet.*;
import sun.audio.*;

public class gsm_player extends Applet implements Runnable {
  static globals globs;
  static int index = 0;
  // indicates which of the two buffers is being used.
  int times;
 // indicates which element of buffer is being played.


/* open url with .gsm file */
  public void open_input(String location) {
    try {
      globs.source.url = new URL(location);
    }
    catch(MalformedURLException e) {
      System.out.println("Error creating URL object.");
      System.exit(-1);
    }
    try {
      globs.source.dp = new DataInputStream(globs.source.url.openStream());
    }
    catch(IOException e) {
      System.out.println("Error opening stream to url.");
      System.exit(-1);
    }
  } 
 
  public void init() {
    String location = getParameter("URL");
	System.out.println("URL for .gsm file is "+location);
    open_input(location); 
	System.out.println("Finished opening stream to URL");
  }

  public void start() {
    if(globs.grabframe == null) {
      globs.grabframe = new Thread(globs.decoder);
      globs.grabframe.start();
    }

    if(globs.player == null) {
      globs.player = new Thread(this);
      globs.player.start();
    }
  }

  public void stop() {
    if(globs.grabframe != null) {
      globs.grabframe.stop();
      globs.grabframe = null;
    }
    if(globs.player != null) {
      globs.player.stop();
      globs.player = null;
    }
  }

  public void run() {

// This is to play the 160 signed 16 bit signals
// that are available in globs.gsmdec.gsm_signal 

    int i;
    long tmp;
	int pointer;
	
    while(globs.grabframe != null && globs.player != null) {
	  if(globs.flag[index] == 0) {
 // suspend if buffer is empty/ has old data
		try {
          globs.awake[1] = false;
		  globs.player.suspend();
		}
		catch(Exception e) {
		  System.out.println("Error in suspend");
		  System.exit(-1);
		}
	  }
	  for(times=0;times<globs.N;times++) {
		 
      for(i=0; i<160; i++) {
// globs.N is size of each buffer, each buffer element is 160 16 bits
		pointer =  160*globs.N*index + 160*times +i;
 

// convert 16 bit signal to byte
		globs.gsmdec.pgsm_signal[pointer] = (byte)convert.S2U(globs.gsmdec.gsm_signal[pointer]);
		      
       }
	  }
	  try {
		  globs.grabframe.suspend();
	  }
	  catch(Exception e) {System.exit(-1);}
// audio play of byte stream
	  AudioData audioData = new AudioData(globs.gsmdec.pgsm_signal);
      AudioDataStream audioStream = new AudioDataStream(audioData);
      AudioPlayer.player.start(audioStream);
	  try {
		  globs.grabframe.resume();
	  }
	  catch(Exception e) {System.exit(-1);}

	  globs.flag[index] = 0;
 // done with playing this buffer, switch to next.
	  index ^= 1;
	  
	  
      if(!globs.awake[0]) { // if grabframe was sleeping, wake it up.
        globs.awake[1] = true;
      try {
	    globs.grabframe.resume();  
      }
      catch(Exception e) {
        System.out.println("Resume error");
        System.exit(-1);
      }
      }

	}

  }
}
